<template>
    <div>
        <custom-card>
            <auto-datatable
                ref="dt"
                model="Setting"
                :filters="[
                    {
                        label: $t('name'),
                        name: 'f-like-setting_name',
                        type: 'text'
                    }
                ]"
                :headers="[
                    {label: '#', name: 'id'},
                    {label: $t('actions'), name: 'actions'},
                    {label: $t('setting'), name: 'setting'},
                    {label: $t('updated_at'), name: 'updated_at'},
                ]"
            >
                <template #default="{records}">
                    <tr
                        v-for="(record, i) in records"
                        :key="i"
                    >
                        <td>{{ i+1 }}</td>
                        <td>
                            <div class="flex justify-start space-x-1">
                                <edit-button
                                    @click="model = record"
                                />
                            </div>
                        </td>
                        <td>{{ record.setting_name }}</td>
                        <td>{{ $helper.dateTimeFormat(record.updated_at) }}</td>
                    </tr>
                </template>
            </auto-datatable>
        </custom-card>
        <panel-modal
            v-if="model"
            :has-footer="false"
            @close="model = null"
        >
            <template #body>
                <model-form
                    :form-model="model"
                    @update="updateRow"
                />
            </template>
        </panel-modal>
    </div>
</template>
<script setup>
import CustomCard from "~/components/custom-card.vue";
import PanelModal from "~/components/panel-modal.vue";
import AutoDatatable from "~/components/auto-datatable.vue";
import {ref} from "vue";
import EditButton from "~/components/button/edit-button.vue";
import ModelForm from './model-form.vue';
import {useSettingStore} from "~/stores/setting.js";

const $settingStore = useSettingStore();
const model = ref(null);
const dt = ref();
const updateRow = async () => {
    model.value = null;

    await dt.value.loadData();
    await $settingStore.fetchSettings();
};
</script>
